package com.gxwebsoft.docs.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.docs.service.DocsContentService;
import com.gxwebsoft.docs.entity.DocsContent;
import com.gxwebsoft.docs.param.DocsContentParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.v3.oas.annotations.tags.Tag;
import io.swagger.v3.oas.annotations.Operation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 文档内容记录表控制器
 *
 * @author 科技小王子
 * @since 2025-03-26 09:29:15
 */
@Tag(name = "文档内容记录表管理")
@RestController
@RequestMapping("/api/docs/docs-content")
public class DocsContentController extends BaseController {
    @Resource
    private DocsContentService docsContentService;

    @PreAuthorize("hasAuthority('docs:docsContent:list')")
    @Operation(summary = "分页查询文档内容记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<DocsContent>> page(DocsContentParam param) {
        // 使用关联查询
        return success(docsContentService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('docs:docsContent:list')")
    @Operation(summary = "查询全部文档内容记录表")
    @GetMapping()
    public ApiResult<List<DocsContent>> list(DocsContentParam param) {
        // 使用关联查询
        return success(docsContentService.listRel(param));
    }

    @PreAuthorize("hasAuthority('docs:docsContent:list')")
    @Operation(summary = "根据id查询文档内容记录表")
    @GetMapping("/{id}")
    public ApiResult<DocsContent> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(docsContentService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('docs:docsContent:save')")
    @OperationLog
    @Operation(summary = "添加文档内容记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody DocsContent docsContent) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
         docsContent.setUserId(loginUser.getUserId());
        }
        if (docsContentService.save(docsContent)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('docs:docsContent:update')")
    @OperationLog
    @Operation(summary = "修改文档内容记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody DocsContent docsContent) {
        if (docsContentService.updateById(docsContent)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('docs:docsContent:remove')")
    @OperationLog
    @Operation(summary = "删除文档内容记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (docsContentService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('docs:docsContent:save')")
    @OperationLog
    @Operation(summary = "批量添加文档内容记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<DocsContent> list) {
        if (docsContentService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('docs:docsContent:update')")
    @OperationLog
    @Operation(summary = "批量修改文档内容记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<DocsContent> batchParam) {
        if (batchParam.update(docsContentService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('docs:docsContent:remove')")
    @OperationLog
    @Operation(summary = "批量删除文档内容记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (docsContentService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
